"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var custom_component_1 = require("./custom.component");
var igniteui_angular2_1 = require("igniteui-angular2");
var northwind_1 = require("./northwind");
var MyColumn = MyColumn_1 = (function (_super) {
    __extends(MyColumn, _super);
    function MyColumn(componentFactoryResolver, viewContainerRef, el) {
        var _this = _super.call(this, el) || this;
        _this.componentFactoryResolver = componentFactoryResolver;
        _this.viewContainerRef = viewContainerRef;
        return _this;
    }
    MyColumn.prototype.ngAfterViewInit = function () {
        var that = this;
        if (window.cmpRefs === undefined) {
            window.cmpRefs = {};
        }
        function template(tmpl, data) {
            if (window.cmpRefs[data["ProductID"]] === undefined) {
                that.factory = that.componentFactoryResolver.resolveComponentFactory(custom_component_1.CustomComponent);
                var cmpRef = that.viewContainerRef.createComponent(that.factory);
                window.cmpRefs[data["ProductID"]] = cmpRef;
            }
            return '';
        }
        jQuery.ig.tmpl = template;
    };
    return MyColumn;
}(igniteui_angular2_1.Column));
MyColumn = MyColumn_1 = __decorate([
    core_1.Directive({
        selector: 'my-column',
        inputs: ['key', 'headerText', 'template', 'width', 'dataType'],
        providers: [{ provide: igniteui_angular2_1.Column, useExisting: MyColumn_1 }]
    }),
    __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, core_1.ViewContainerRef, core_1.ElementRef])
], MyColumn);
exports.MyColumn = MyColumn;
var AppComponent = (function () {
    function AppComponent() {
        this.data = northwind_1.Northwind.getData();
        this.id = 'grid1';
        this.features = [{ name: "Sorting" }];
    }
    AppComponent.prototype.renderedCallback = function ($event) {
        var customComponents = window.cmpRefs;
        var id, nativeElement;
        if (customComponents !== undefined) {
            jQuery($event.ui.owner.element)
                .find("tbody td[aria-describedby='grid1_CustomComponent']")
                .each(function (index, element) {
                id = jQuery(element).parent().data('id');
                nativeElement = jQuery(customComponents[id].location.nativeElement);
                //append the native element of you custom component into the cell
                nativeElement.appendTo(element);
            });
        }
    };
    return AppComponent;
}());
AppComponent = __decorate([
    core_1.Component({
        selector: 'my-app',
        template: "<h1 id='mainheader'>My IgniteUI Angular2 App</h1>\n    <div class=\"row\">\n        <div class=\"col-md-8\">\n            <ig-grid [widgetId]='id' (dataRendered)='renderedCallback($event)' [width]='w' [autoCommit]='true' [(dataSource)]='data' [height]='h' [autoGenerateColumns]='false' [primaryKey]='\"ProductID\"' [features]='features'>\n                <column [key]=\"'ProductID'\" [headerText]=\"'ProductID'\" [width]=\"'165px'\" [dataType]=\"'number'\"></column>\n                <column [key]=\"'ProductName'\" [headerText]=\"'Product Name'\" [width]=\"'150px'\" [dataType]=\"'string'\"></column>\n                <column [key]=\"'QuantityPerUnit'\" [headerText]=\"'Quantity per unit'\" [width]=\"'150px'\" [dataType]=\"'string'\"></column>\n                <column [key]=\"'UnitPrice'\" [headerText]=\"'Unit Price'\" [width]=\"'100px'\" [dataType]=\"'number'\"></column>\n                <my-column [key]=\"'CustomComponent'\" [headerText]=\"'Custom component'\" [width]=\"'200px'\" [dataType]=\"'number'\" [template]=\"'<custom-component></custom-component>'\"></my-column>\n            </ig-grid>\n        </div>\n    </div>\n    "
    }),
    __metadata("design:paramtypes", [])
], AppComponent);
exports.AppComponent = AppComponent;
var MyColumn_1;
//# sourceMappingURL=app.component.js.map